using System; 
using System.IO; 
using System.Collections.Generic;


	public class FileOpenMemorySorting  {
	
		
		public FileOpenMemorySorting(string filename){
		
			fileName = filename;
		
			if (fileName.EndsWith(".s19") == true) {
				Console.WriteLine("Файл имеет расширение .s19");
				MotorolaS19file s19File = new MotorolaS19file(fileName);
				errorMessages = new MotorolaS19file(fileName).GetErrorMessages();
				AllMemoryAddressByte = new MotorolaS19file(fileName).GetAddressByteSorted();
				//RAMaddressByteSorted = new MotorolaS19file(fileName).GetAddressByteSorted();
				//EEPROMaddressByteSorted = new MotorolaS19file(fileName).GetAddressByteSorted();
				//FLASHaddressByteSorted = new MotorolaS19file(fileName).GetAddressByteSorted();
				AllMemoryAddressByteSorting();
			}
			else if (fileName.EndsWith(".hex") == true) {
				Console.WriteLine("Файл имеет расширение .hex");
				//IntelHEXfile hexFile = new IntelHEXfile(fileName);
				errorMessages = new IntelHEXfile(fileName).GetErrorMessages();
				AllMemoryAddressByte = new IntelHEXfile(fileName).GetAddressByteSorted();
				//RAMaddressByteSorted = new IntelHEXfile(fileName).GetAddressByteSorted();
				//EEPROMaddressByteSorted = new IntelHEXfile(fileName).GetAddressByteSorted();
				//FLASHaddressByteSorted = new IntelHEXfile(fileName).GetAddressByteSorted();
				AllMemoryAddressByteSorting();
				}
			else {
				Console.WriteLine("Файл имеет расширение отличное от .s19 или .hex");
				Console.ReadKey();
				return;
			}
		
		}// FileOpenMemorySorting(string filename)
	

			void AllMemoryAddressByteSorting() {
				RAMaddressByteSorted = new SortedDictionary<long, byte>(AllMemoryAddressByte);
				EEPROMaddressByteSorted = new SortedDictionary<long, byte>(AllMemoryAddressByte);
				FLASHaddressByteSorted = new SortedDictionary<long, byte>(AllMemoryAddressByte);
				
				foreach(KeyValuePair<long, byte> kvp in AllMemoryAddressByte){
					if(kvp.Key < 0x00000000L | kvp.Key > 0x000003FFL) RAMaddressByteSorted.Remove(kvp.Key);
					if(kvp.Key < 0x00004000L | kvp.Key > 0x0000427FL) EEPROMaddressByteSorted.Remove(kvp.Key);
					if(kvp.Key < 0x00008000L | kvp.Key > 0x00009FFFL) FLASHaddressByteSorted.Remove(kvp.Key);	
				}
			}// AllMemoryAddressByteSorting

        	public SortedDictionary<long, byte> GetAllMemoryaddressByteSorted() { return AllMemoryAddressByte; }
        	public SortedDictionary<long, byte> GetRAMaddressByteSorted() { return RAMaddressByteSorted; }
        	public SortedDictionary<long, byte> GetEEPROMaddressByteSorted() { return EEPROMaddressByteSorted; }
        	public SortedDictionary<long, byte> GetFLASHaddressByteSorted() { return FLASHaddressByteSorted; }
        	
			string fileName;
			string[] errorMessages;
			SortedDictionary<long, byte> AllMemoryAddressByte;
			SortedDictionary<long, byte> RAMaddressByteSorted;
			SortedDictionary<long, byte> EEPROMaddressByteSorted;
			SortedDictionary<long, byte> FLASHaddressByteSorted;
			
	}// class FileOpenMemorySorting 


